<?php
/**
 * Plugin Name: Dadevarzan WordPress video plugin
 * Plugin URI: https://wordpress.org/plugins/dadevarzan-wp-video
 * Description: video post type for wordpress
 * Version: 1.2.3
 * Author: Dadevarzan Team
 * Author URI: http://www.dadevarzan.com
 * Text Domain:      
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
    die;
}

if ( !class_exists( 'dadevarzanWpVideo' ) ) {

    class dadevarzanWpVideo
    {
        public static function initialize()
        {

            add_action( 'plugins_loaded', 'dadevarzanWpVideo::load_text_domain' );
            add_action( 'init', 'dadevarzanWpVideo::add_post_type' );
            add_action( 'init', 'dadevarzanWpVideo::add_fields' );
            add_action('init', 'dadevarzanWpVideo::add_role_caps');
            add_action('init', 'dadevarzanWpVideo::add_taxonomy');
            add_action( 'plugins_loaded', 'dadevarzanWpVideo::load_templates' );

        }

        public static function add_post_type()
        {

            $labels = array(
                "name" => __('Video Gallery', 'dadevarzan-wp-video'),
                "singular_name" => __('Video', 'dadevarzan-wp-video'),
                "menu_name" => __('Video Gallery', 'dadevarzan-wp-video'),
                "all_items" => __('All Videos', 'dadevarzan-wp-video'),
                "add_new" => __('Add Video', 'dadevarzan-wp-video'),
                "add_new_item" => __('Add New Video', 'dadevarzan-wp-video'),
                "edit_item" => __('Edit Video', 'dadevarzan-wp-video'),
                "view_item" => __('View Video', 'dadevarzan-wp-video')
            );

            $args = array(
                "label" => __('Video Gallery', 'dadevarzan-wp-video'),
                "labels" => $labels,
                "description" => "",
                "public" => true,
                "publicly_queryable" => true,
                "show_ui" => true,
                "show_in_rest" => true,
                "rest_base" => "",
				"show_in_nav_menus" => true,
                "has_archive" => true,
                "show_in_menu" => true,
				"show_in_nav_menus" => true,
                "exclude_from_search" => false,
                "hierarchical" => false,
                "rewrite" => array( "slug" => "video", "with_front" => true ),
                "query_var" => true,
                "menu_icon" => "dashicons-video-alt2",
                "supports" => array( "title", "excerpt", "editor", "thumbnail", "comments", "author" ),
                "capability_type" => array('video', 'videos'),
                "map_meta_cap" => true,
                "taxonomies" => array( "video_category" ),
            );

            register_post_type( 'video', $args );

        }

        public static function add_fields()
        {

            if( function_exists('acf_add_local_field_group') ):

                acf_add_local_field_group(array(
                    'key' => 'group_5981affb87117',
                    'title' => __('Video Gallery', 'dadevarzan-wp-video'),
					'fields' => array(
						array(
							'key' => 'field_5ddb8849b32bf',
							'label' => __('Video Source', 'dadevarzan-wp-video'),
							'name' => 'video_source',
							'type' => 'radio',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => 0,
							'wrapper' => array(
								'width' => '',
								'class' => '',
								'id' => '',
							),
							'choices' => array(
								'media' => __('Media Center', 'dadevarzan-wp-video'),
								'embed' => __('Embed', 'dadevarzan-wp-video'),
								'internet' => __('Internet', 'dadevarzan-wp-video'),
							),
							'allow_null' => 0,
							'other_choice' => 0,
							'default_value' => 'media',
							'layout' => 'vertical',
							'return_format' => 'value',
							'save_other_choice' => 0,
						),
						array(
							'key' => 'field_5981b1703a57e',
							'label' => __('MP4 File', 'dadevarzan-wp-video'),
							'name' => 'mp4',
							'type' => 'file',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => array(
								array(
									array(
										'field' => 'field_5ddb8849b32bf',
										'operator' => '==',
										'value' => 'media',
									),
								),
							),
							'wrapper' => array(
								'width' => '',
								'class' => '',
								'id' => '',
							),
							'return_format' => 'array',
							'library' => 'all',
							'min_size' => '',
							'max_size' => '',
							'mime_types' => 'mp4,mpeg,mpg,wma,webm',
						),
						array(
							'key' => 'field_5ddb889fb32c0',
							'label' => __('Embed', 'dadevarzan-wp-video'),
							'name' => 'video_embed',
							'type' => 'wysiwyg',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => array(
								array(
									array(
										'field' => 'field_5ddb8849b32bf',
										'operator' => '==',
										'value' => 'embed',
									),
								),
							),
							'wrapper' => array(
								'width' => '',
								'class' => '',
								'id' => '',
							),
							'default_value' => '',
							'tabs' => 'text',
							'media_upload' => 0,
							'toolbar' => 'full',
							'delay' => 0,
						),
						array(
							'key' => 'field_5ddb896a8d95a',
							'label' => __('URL', 'dadevarzan-wp-video'),
							'name' => 'video_url',
							'type' => 'url',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => array(
								array(
									array(
										'field' => 'field_5ddb8849b32bf',
										'operator' => '==',
										'value' => 'internet',
									),
								),
							),
							'wrapper' => array(
								'width' => '',
								'class' => '',
								'id' => '',
							),
							'default_value' => '',
							'placeholder' => '',
						),
					),
                    'location' => array(
                        array(
                            array(
                                'param' => 'post_type',
                                'operator' => '==',
                                'value' => 'video',
                            ),
                        ),
                    ),
                    'menu_order' => 0,
                    'position' => 'acf_after_title',
                    'style' => 'default',
                    'label_placement' => 'top',
                    'instruction_placement' => 'label',
                    'hide_on_screen' => '',
                    'active' => 1,
                    'description' => '',
                ));

            endif;

        }

        public static function add_taxonomy()
        {

            $labels = array(
                "name" => __('Video Categories', 'dadevarzan-wp-video'),
                "singular_name" => __('Video Category', 'dadevarzan-wp-video'),
            );

            $args = array(
                "label" => __('Video Categories', 'dadevarzan-wp-video'),
                "labels" => $labels,
                "public" => true,
                "hierarchical" => true,
                "show_ui" => true,
                "show_in_menu" => true,
                "show_in_nav_menus" => true,
                "query_var" => true,
                "rewrite" => array( 'slug' => 'video_category', 'with_front' => true, ),
                "show_in_nav_menus" => true,
                "show_admin_column" => true,
                "show_in_rest" => true,
                "rest_base" => "",
                "show_in_quick_edit" => true,
                'capabilities' => array(
                    'manage_terms' => 'manage_categories',
                    'edit_terms' => 'manage_categories',
                    'delete_terms' => 'manage_categories',
                    'assign_term' => 'manage_categories',
                    'assign_terms' => 'manage_categories',
                ),
            );

            register_taxonomy( 'video_category', array( 'video' ), $args );

        }

        public static function add_role_caps()
        {

            // Add the roles you'd like to administer the custom post types
            $roles = array('wpseo_editor', 'wpseo_manager', 'shop_manager', 'editor', 'administrator');

            // Loop through each role and assign capabilities
            foreach($roles as $the_role) {

                $role = get_role($the_role);

                if ( empty($role) ) {
                    continue;
                }

                $role->add_cap( 'read' );
                $role->add_cap( 'read_video' );
                $role->add_cap( 'edit_video' );
                $role->add_cap( 'edit_videos' );
                $role->add_cap( 'edit_private_videos' );
                $role->add_cap( 'edit_published_videos' );
                $role->add_cap( 'edit_others_videos' );
                $role->add_cap( 'delete_video' );
                $role->add_cap( 'delete_videos' );
                $role->add_cap( 'delete_private_videos' );
                $role->add_cap( 'delete_published_videos' );
                $role->add_cap( 'delete_others_videos' );
                $role->add_cap( 'publish_videos' );
                $role->add_cap( 'read_private_videos' );

            }

        }

        public static function load_templates() {

            /**
             * Return if the builder isn't installed or if the current
             * version doesn't support registering templates.
             */
            if ( ! class_exists( 'FLBuilder' ) || ! method_exists( 'FLBuilder', 'register_templates' ) ) {
                return;
            }

            $layoutTemplatePath = plugin_dir_path( __FILE__ ) . 'data/templates.dat';
            if ( file_exists( $layoutTemplatePath ) && class_exists( 'FLThemeBuilder' ) ) {
                FLBuilder::register_templates( $layoutTemplatePath, array('group' => 'video'));
            }

        }

        public static function load_text_domain()
        {
            load_plugin_textdomain( 'dadevarzan-wp-video' , FALSE, basename( dirname( __FILE__ ) ) . '/languages'  );
        }

    }

    dadevarzanWpVideo::initialize();

}